(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: AM2302.PAS                                                     *)
(*  Obsah: ovladani cidla teploty a vlhkosti                               *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 25.5.2014                                             *)
(*  Pro kompilaci: viz Uses                                                *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program ovladac_cidla;
{$I-}
uses cas,klavesy2,texty2,textmenu,retezce,dos;

var uart_base:array[1..4] of word absolute 0:$0400; {bazove adresy portu
     ulozene v BIOSu, obvykle $3F8,$2F8,$3E8 a $2E8, neexistujici jsou nulove}
    ba:word; {bazova adresa vybraneho portu}
    ZapleCidlo:boolean; {jestli je zapnute napajeni cidla}
    pockat:word; {jak dlouho [ms] se ma cekat, nez bude cidlo schopne dalsi prace}
    HlavniMenu,    {hlavni nabidka}
    PortMenu,      {nabidka pro vyber portu}
    AutMenu:tmenu; {nabidka pro nastaveni automatickeho mereni}
    stopky:timer; {hodinky pro pocitani intervalu automatickeho mereni}
    zaznam:text; {soubor, do ktereho se zapisuji namerene hodnoty}
    JmenoZaznamu:string[79]; {jmeno toho souboru}
    interval:longint; {doba mezi dvema merenimi [s]}
    inth,intmin:word; {to same v hodinach a minutach (nakonec se to prevede na vteriny)}
    radek, {text pro ulozeni do zaznamu a zaroven vypsani na obrazovku}
    odpoved:string; {co napise uzivatel}


procedure ZapniCidlo;
Begin
port[ba+4]:=2; {RTS:=1}
zaplecidlo:=true;
pockat:=1000;  {po zapnuti cidla se ma vterinu pockat, nez nabehne}
startcekani;
hlavnimenu.prepispolozku(2,'Napajeni cidla: zapnute');
End;{zapnicidlo}

procedure VypniCidlo;
Begin
port[ba+4]:=0; {RTS:=0}
zaplecidlo:=false;
hlavnimenu.prepispolozku(2,'Napajeni cidla: vypnute');
End;{vypnicidlo}

function Linka:byte; {vraci aktualni stav datove linky (0=L, 1=H)}
Begin
linka:=(port[ba+6] shr 4) and 1; {CTS}
End;{linka}

function Mereni:string; {precte hodnoty z cidla a vysledky vrati ve forme
 textu (vcetne vsech pripadnych chybovych hlasek)}
var pole:array[1..40] of word; {nejdriv namerene delky impulsu, potom vypocitane hodnoty datovych bitu}
    maximum:word; {nejvetsi delka impulsu}
    i,w,vlhkost:word;
    teplota:integer;
    SoucetZCidla, {kontrolni soucet ziskany primo z cidla}
    MujSoucet:byte; {kontrolni soucet vypocitany z namerenych hodnot}
    vysledek:string;
{}function timeout:boolean; {pojistka proti nekonecnemu zacykleni cekacich smycek}
{}Begin
{}if getms>500 then begin {podle dokumentace mereni netrva dele nez 2 s; jestli jsme to prekrocili, je to spatne}
{}                  mereni:=', , ** Chyba komunikace - neprisel ocekavany signal!';
{}                  timeout:=true;
{}                  end
{}             else timeout:=false; {v poradku, pokracujeme}
{}End;{timeout}
Begin
if not zaplecidlo then zapnicidlo;
vysledek:='';
fillchar(pole,sizeof(pole),0);
repeat until dosazencas(pockat); {cekani na vzpamatovani cidla po zapnuti nebo minulem mereni}
if linka=0 then begin
                mereni:=', , ** Chyba zapojeni - na datove lince neni napeti!';
                exit;
                end;
pockat:=2000; {2 s do pristiho mereni}
startcekani; {pro pocitani timeoutu a casu do priste}
port[ba+4]:=3; {shod datovou linku na L (DTR=1, tranzistor je otevreny)}
repeat until getms>=10; {ted se ma pockat nejmene 1..10 ms}
port[ba+4]:=2; {nahod linku zpatky na H (DTR=0, tranzistor je zavreny)}
repeat if timeout then exit until linka=0; {cekani na odpoved cidla, potrva to 20..40 us (mikrosekund)}
repeat if timeout then exit until linka=1; {cekani na konec odpovedi, 80 us}
repeat if timeout then exit until linka=0; {cekani na zacatek prvniho bitu, 80 us}
for i:=1 to 40 do begin
                  repeat if timeout then exit until linka=1; {cekani na zacatek urovne H}
                   repeat {mereni doby trvani urovne H}
                   inc(pole[i]);
                   {Rychlost pricitani zavisi na rychlosti procesoru, ale
                   ani na gigahertzovych procesorech namerene casy nepresahuji
                   stovku, tak snad preteceni nehrozi. Hlavne je potreba, aby
                   na pozadi nebezelo zadne asynchronni preruseni, jinak je
                   cele mereni v haji.}
                   if timeout then exit;
                   until linka=0;
                  end;
repeat if timeout then exit until linka=1; {cekani na navrat do vychoziho stavu - jen tak pro poradek}
{zpracovani namerenych hodnot:
Hodnotu 1 vyjadruje puls o delce 70 us, hodnotu 0 26..28 us. Mikrosekundy
nejdou merit primo, tak vezmu nejdelsi namereny cas a prohlasim ho za 70 us.
Vsechno, co je mensi nez polovina toho maxima, bude 0, to vetsi bude 1.}
maximum:=pole[1];
for i:=2 to 40 do if pole[i]>maximum then maximum:=pole[i]; {nalezeni maxima}
for i:=1 to 40 do if pole[i]>maximum shr 1 then pole[i]:=1 {urceni hodnoty bitu}
                                           else pole[i]:=0;
{ted mame v poli misto casu bity, slozime z nich cisla:}
vlhkost:=0;
for i:=1 to 16 do vlhkost:=vlhkost shl 1+pole[i]; {vlhkost je jednoduche kladne cislo, neni co resit}
w:=0; {teplota ma v nejvyssim bitu znamenko, bude potreba trochu pocitani}
for i:=17 to 32 do w:=w shl 1+pole[i]; {nejdriv zpracujeme vsech 16 bitu}
if pole[17]=1 then teplota:=-(w and $7FFF) {zapornou teplotu je treba prevest na tvar, kteremu rozumi PC}
              else teplota:=w; {kladnou hodnotu muzeme vzit tak, jak je}
vysledek:=nastrr(vlhkost/10,1)+', '+nastrr(teplota/10,1);
{a kontrolni soucet:}
mujsoucet:=(lo(vlhkost)+hi(vlhkost)+lo(w)+hi(w)) and $FF;
soucetzcidla:=0;
for i:=33 to 40 do soucetzcidla:=soucetzcidla shl 1+pole[i];
if soucetzcidla<>mujsoucet then vysledek:=vysledek+', ** Nesedi kontrolni soucet!';
mereni:=vysledek;
End;{mereni}

function RozbalVysledek(vysledek:string):string;
{Rozbali vysledek funkce Mereni z CSV do lidsky citelneho formatu. Celkem
zbytecna prace (stacilo by ty vysledky ulozit do samostatnych promennych),
ale proc si trochu nepocvicit rozebirani stringu :-).}
var p:byte;
    v,t:string[10]; {vlhkost a teplota}
    ch:string[50]; {pripadna chybova hlaska}
Begin
v:=strip(dejslovo(vysledek,',',1),'o',' ');
if v='' then v:='?';
v:=zarovnej(v,5,_doprava,' ');
t:=strip(dejslovo(vysledek,',',2),'o',' ');
if t='' then t:='?';
t:=zarovnej(t,6,_doprava,' ');
ch:=strip(dejslovo(vysledek,',',3),'o',' ');
rozbalvysledek:='Vlhkost: '+v+' %, teplota: '+t+' stupnu C. '+ch;
End;{rozbalvysledek}

procedure cls2; {jen pro zkraceni zapisu}
Begin
vymazoblast(4,24,7);
End;{cls2}

function ZadejText(vyzva:string):string; {zadavani textu z klavesnice}
var r:string;
Begin
write(vyzva,': ');
tkurzorzap;
readln(r);
tkurzorvyp;
zadejtext:=r;
End;{zadejtext}

procedure KresliHlavicku;
Begin
writexy(8,1,4,'Program na cteni hodnot z cidla vlhkosti a teploty AM2302/DHT22');
writexy(8,2,1,kolikceho(63,'='));
writexy(30,25,8,'(cc) Mircosoft 2014');
End;{kreslihlavicku}

function DatumACas:string; {vraci aktualni datum a cas v textove podobe}
var rok,mesic,den,hodiny,minuty,sekundy,knicemu:word;
Begin
getdate(rok,mesic,den,knicemu);
gettime(hodiny,minuty,sekundy,knicemu);
datumacas:=nastr(den)+'.'+nastr(mesic)+'.'+nastr(rok)+', '
          +nastr3(hodiny,2)+':'+nastr3(minuty,2)+':'+nastr3(sekundy,2);
End;{datumacas}

BEGIN
nastavtextak80x25;
tkurzorvyp;
kreslihlavicku;

{hlavni nabidka:}
with hlavnimenu do
 begin
 init(4);
 polozka('Port: COM1'); {1}
 popis('Tady si muzete vybrat port, na kterem mate cidlo pripojene.');
 polozka('Napajeni cidla: vypnute'); {2}
 popis('Stiskem Enteru muzete rucne zapnout nebo vypnout napajeni cidla (linku RTS).');
 popis('Ale neni to nutne, pred merenim se zapne a pred koncem programu vypne');
 popis('automaticky.');
 polozka('Rucni mereni'); {3}
 popis('Mereni se spousti jednorazove stiskem klavesy.');
 polozka('Automaticke mereni'); {4}
 popis('Namerene hodnoty se na obrazovce aktualizuji automaticky kazde dve vteriny.');
 polozka('Dlouhodobe mereni se zaznamem'); {5}
 popis('Meri se automaticky v zadanych casovych intervalech a vysledky se');
 popis('zaznamenavaji do souboru.');
 polozka('Konec programu'); {6}
 popis('Nebo staci zmacknout Esc.');
 end;

{nabidka pro vyber portu:}
portmenu.init(4);
ba:=1; {docasne zneuziti promenne pro cislo portu}
while (ba<=4)and(uart_base[ba]<>0) do begin
                                      portmenu.polozka('COM'+chr(ba+ord('0')));
                                      inc(ba);
                                      end;
if portmenu.pocetpolozek=0
  then begin
       writexy(10,10,12,'Tenhle pocitac nema seriovy port, cidlo neni kam pripojit.');
       writexy(25,12,7,'Konec libovolnou klavesou.');
       krcr;
       cls(7); gotoxy(1,1); tkurzorzap;
       halt;
       end;

{nabidka pro nastaveni automatickeho mereni:}
jmenozaznamu:='NAMERENO.CSV';
interval:=60;
with autmenu do
 begin
 init(4);
 polozka('Soubor pro zaznam: '+jmenozaznamu); {1}
 popis('Tady si nastavte jmeno souboru, do ktereho chcete ukladat namerene hodnoty.');
 popis('Pokud soubor neexistuje, bude vytvoren. Pokud existuje, budou se nova');
 popis('mereni pripisovat na jeho konec.');
 popis('Na koncovce nezalezi, vnitrni format je vzdy CSV (hodnoty oddelene carkami).');
 popis('Cist se da bud primo jako cisty text, nebo dale zpracovat treba Excelem.');
 polozka('Interval mereni: 00:01:00'); {2}
 popis('Tady zadejte, jak casto se ma merit (interval v hodinach, minutach');
 popis('a vterinach). Puvodni hodnoty jsou zobrazeny v <zavorkach>, stisknutim');
 popis('Enteru bez zadavani noveho cisla ponechate to puvodni.');
 polozka('Start'); {3}
 popis('Timhle se mereni odstartuje.');
 polozka('Zpet'); {4}
 popis('Timhle nebo klavesou Esc se vratite na hlavni nabidku.');
 end;

ba:=uart_base[1]; {pro zacatek vybereme COM1}
zaplecidlo:=false;
pockat:=0;

 repeat
 {v tomhle okamziku musi byt obrazovka pripravena pro zobrazeni hlavniho menu,
 tj. nahore hlavicka a pod ni bud nic, nebo hlavni menu od minula}
 hlavnimenu.kontrola;
 if hlavnimenu.zruseno then break;
 case hlavnimenu.hodnota of
   1:begin {port}
     if zaplecidlo then vypnicidlo;
     cls2;
     portmenu.kontrola;
     if not portmenu.zruseno then begin
                                  ba:=uart_base[portmenu.hodnota];
                                  hlavnimenu.prepispolozku(1,'Port: COM'+nastr(portmenu.hodnota));
                                  end;
     cls2;
     end;
   2:if zaplecidlo then vypnicidlo
                   else zapnicidlo;
   3:begin {rucni mereni}
     cls2;
     writexy(7,6,7,'Mereni spustite libovolnou klavesou, Esc vraci na hlavni nabidku.');
      repeat
      inth:=xreadkey; {nechce se mi deklarovat dalsi promennou, inth bude stacit :-]}
      if inth<>xesc then begin
                         vymazradek(10,7);
                         vymazradek(11,7);
                         writexy(35,10,4+128,'Merim...');
                         radek:=rozbalvysledek(mereni);
                         vymazradek(10,7);
                         writexy(15,10,2,dejslovo(radek,'**',1)); {vysledky}
                         writexy(15,11,4,strip(dejslovo(radek,'**',2),'l',' ')); {chybova hlaska}
                         end;
      until inth=xesc;
     cls2;
     end;
   4:begin {souvisle mereni}
     cls2;
     writexy(4,6,7,'Libovolnou klavesou mereni ukoncite a vratite se zpatky na hlavni nabidku.');
     writexy(35,10,4+128,'Merim...');
      repeat
      radek:=rozbalvysledek(mereni);
      vymazradek(10,7);
      vymazradek(11,7);
      writexy(15,10,2,dejslovo(radek,'**',1)); {vysledky}
      writexy(15,11,4,strip(dejslovo(radek,'**',2),'l',' ')); {chybova hlaska}
      until keypressed;
     kresetuj;
     cls2;
     end;
   5:begin {zaznam}
     cls2;
      repeat
      autmenu.kontrola;
      if autmenu.zruseno then break;
      case autmenu.hodnota of
        1:begin {soubor}
          vymazoblast(9,24,7);
          gotoxy(2,10);
          odpoved:=zadejtext('Zadejte jmeno souboru <'+jmenozaznamu+'>');
          if odpoved<>'' then begin
                              jmenozaznamu:=stringup(odpoved);
                              autmenu.prepispolozku(1,'Soubor pro zaznam: '+jmenozaznamu);
                              end;
          vymazoblast(9,24,7);
          end;
        2:begin {interval}
          inth:=interval div 3600;
          interval:=interval mod 3600;
          intmin:=interval div 60;
          interval:=interval mod 60;
          vymazoblast(9,24,7);
          gotoxy(2,10);
          writeln('Zadejte interval v hodinach, minutach a sekundach.');
          odpoved:=zadejtext('Hodiny <'+nastr3(inth,2)+'>');
          if odpoved<>'' then inth:=valf(odpoved,inth);
          odpoved:=zadejtext('Minuty <'+nastr3(intmin,2)+'>');
          if odpoved<>'' then intmin:=valf(odpoved,intmin);
          odpoved:=zadejtext('Sekundy <'+nastr3(interval,2)+'>');
          if odpoved<>'' then interval:=valf(odpoved,interval);
          autmenu.prepispolozku(2,'Interval mereni: '+nastr3(inth,2)+':'+nastr3(intmin,2)+':'+nastr3(interval,2));
          interval:=interval+longint(60)*intmin+longint(3600)*inth;
          if interval<2 then interval:=2; {minimum je 2 s, rychleji to cidlo nezvlada}
          vymazoblast(9,24,7);
          end;
        3:begin {start}
          vymazoblast(4,25,7);
          gotoxy(1,4);
          writeln('Probiha automaticke mereni v zadanych intervalech.');
          writeln('Pro ukonceni a navrat do hlavni nabidky stisknete Esc.');
          writeln;
          {priprava souboru:}
          assign(zaznam,jmenozaznamu);
          reset(zaznam); close(zaznam); {existuje?}
          if ioresult<>0 then begin     {ne}
                              rewrite(zaznam); close(zaznam);
                              if ioresult<>0 then begin
                                                  writeln('** Pozor, soubor ',jmenozaznamu,' se nepodarilo vytvorit.');
                                                  writeln('** Merime bez zaznamu!');
                                                  writeln;
                                                  end;
                              end;
          {hlavicka tabulky:}
          radek:='Datum, Cas, Vlhkost [%], Teplota [st. C], Poznamky';
          append(zaznam);
          writeln(zaznam,kolikceho(40,'-'));
          writeln(zaznam,radek);
          close(zaznam);
          if ioresult<>0 then {ted to nema cenu hlasit};
          writeln(radek);
          {a jedeme:}
           repeat
           {nejdriv mereni:}
           radek:=datumacas+', '+mereni;
           {potom zaznam:}
           append(zaznam);
           writeln(zaznam,radek);
           close(zaznam);
           if ioresult<>0 then radek:=radek+', ** Chyba zaznamu!';
           writeln(radek); {kontrolni vypis na obrazovku}
           {a nakonec cekani do pristiho mereni nebo na ukonceni Escapem:}
           stopky.init(interval);
            repeat
            if keypressed then inth:=xreadkey else inth:=0;
            until (stopky.read<=0) or (inth=xesc);
           until inth=xesc;
          {jeste uklid obrazovky:}
          cls(7);
          kreslihlavicku;
          end;
        end;
      until autmenu.hodnota=4;
     cls2;
     end;
   end;
 until hlavnimenu.hodnota=6;

{zaverecny uklid:}
if zaplecidlo then vypnicidlo;
cls(7);
gotoxy(1,1);
tkurzorzap;
END.
